#include<unistd.h>
#include<sys/time.h>

#define TRUE 1
#define FALSE 0
#define MAXCHAR 100

#define RING 0
#define FAN 1
#define BIDIR 2
#define REC 3
#define BUCK 4
#define MPI 5
#define PIPE 6
#define BING 7
#define NAIVE 8
#define FOURWAY 9

#define GATHER 0
#define REDUCE 1
#define REDSCAT 2

#define pt(x) printf("Got to point %d\n",x)
#define ft(x) printf("Got to point %f\n",x)
#define sd(x,y) printf("%d Sending %d\n",x,y)
#define sd2(x,y) printf("%d Sent %d\n",x,y)
#define rd(x,y) printf("%d Receiving %d\n",x,y)
#define rd2(x,y) printf("%d Received %d\n",x,y)

struct args{
  int numelem;
  int numiter;
  int type;
  int op;
  int block;
  int numsteps;
  int stepsize;
  int print;
  int output;
  int compute;
  int notpow;
  int testrank;
  int check;
  int ring;
  int printtype;
};

int processArgs(int, char **, struct args *, int);
void argErr();

int verify(struct args *, int, int); 

long gettimediff(struct timeval *, struct timeval *);

int ring_gather(double *, double *, struct args *, int, int);
int fan_gather(double *, double *, struct args *, int, int);
int bidir_gather(double *, double *, struct args *, int, int);
int rec_gather(double *, double *, struct args *, int, int);
int buck_gather(double *, double *, struct args *, int, int);
int mpi_gather(double *, double *, struct args *, int, int);
int pipe_gather(double *, double *, struct args *, int, int);
int bing_gather(double *, double *, struct args *, int, int);
int naive_gather(double *, double *, struct args *, int, int);
int fourway_gather(double *, double *, struct args *, int, int);

int b_ring_gather(double *, double *, struct args *, int, int);
int b_fan_gather(double *, double *, struct args *, int, int);
int b_bidir_gather(double *, double *, struct args *, int, int);
int b_rec_gather(double *, double *, struct args *, int, int);
int b_buck_gather(double *, double *, struct args *, int, int);
int b_pipe_gather(double *, double *, struct args *, int, int);

int ring_reduce(double *, double *, struct args *, int, int);
int fan_reduce(double *, double *, struct args *, int, int);
int bidir_reduce(double *, double *, struct args *, int, int);
int rec_reduce(double *, double *, struct args *, int, int);
int buck_reduce(double *, double *, struct args *, int, int);
int mpi_reduce(double *, double *, struct args *, int, int);
int pipe_reduce(double *, double *, struct args *, int, int);
int naive_reduce(double *, double *, struct args *, int, int);
int fourway_reduce(double *, double *, struct args *, int, int);

int b_ring_reduce(double *, double *, struct args *, int, int);
int b_fan_reduce(double *, double *, struct args *, int, int);
int b_bidir_reduce(double *, double *, struct args *, int, int);
int b_rec_reduce(double *, double *, struct args *, int, int);
int b_buck_reduce(double *, double *, struct args *, int, int);
int b_mpi_reduce(double *, double *, struct args *, int, int);
int b_pipe_reduce(double *, double *, struct args *, int, int);

int ring_redscat(double *, double *, struct args *, int, int, int *);
int fan_redscat(double *, double *, struct args *, int, int, int *);
int bidir_redscat(double *, double *, struct args *, int, int, int *);
int rec_redscat(double *, double *, struct args *, int, int, int *);
int buck_redscat(double *, double *, struct args *, int, int, int *);
int mpi_redscat(double *, double *, struct args *, int, int, int *);
int pipe_redscat(double *, double *, struct args *, int, int, int *);
int bing_redscat(double *, double *, struct args *, int, int, int *);
int naive_redscat(double *, double *, struct args *, int, int, int *);
int fourway_redscat(double *, double *, struct args *, int, int, int *);

int b_ring_redscat(double *, double *, struct args *, int, int, int *);
int b_fan_redscat(double *, double *, struct args *, int, int, int *);
int b_bidir_redscat(double *, double *, struct args *, int, int, int *);
int b_rec_redscat(double *, double *, struct args *, int, int, int *);
int b_buck_redscat(double *, double *, struct args *, int, int, int *);
int b_mpi_redscat(double *, double *, struct args *, int, int, int *);
int b_pipe_redscat(double *, double *, struct args *, int, int, int *);







